
freeslot("S_SMW_SWIMIDLE", "S_SMW_SWIM", "sfx_smwswm")

sfxinfo[sfx_smwswm].caption = "Swim"

states[S_SMW_SWIMIDLE] = {
    sprite = SPR_PLAY,
    frame = SPR2_FLY_,
    tics = -1,
    nextstate = S_SMW_SWIMIDLE
}

states[S_SMW_SWIM] = {
    sprite = SPR_PLAY,
    frame = SPR2_SWIM|FF_SPR2ENDSTATE,
    tics = 5,
	var1 = S_SMW_SWIMIDLE,
    nextstate = S_SMW_SWIM
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if (p.cmd.buttons & BT_JUMP)
		p.smwjumpheld = $+1
	else
		p.smwjumpheld = 0
	end
	
	if (p.mo.eflags & MFE_UNDERWATER)
		if p.mo.state ~= S_SMW_SWIM
		and not P_IsObjectOnGround(p.mo)
			p.mo.state = S_SMW_SWIMIDLE
		end
		if p.smwjumpheld == 1
		and p.mo.state ~= S_SMW_SWIM
			S_StopSoundByID(p.mo, skins[p.mo.skin].soundsid[SKSJUMP])
			p.pflags = $ & ~PF_JUMPED
			P_DoJump(p, false)
			p.mo.state = S_SMW_SWIM
			S_StartSound(p.mo, sfx_smwswm)
		end
	elseif (p.mo.state == S_SMW_SWIM or p.mo.state == S_SMW_SWIMIDLE)
	and (p.cmd.buttons & BT_JUMP)
		p.pflags = $ & ~PF_JUMPED
		S_StopSoundByID(p.mo, sfx_smwswm)
		P_DoJump(p, true)
	end
end)